#!/usr/bin/perl

use CGI (':param', ':Vars');
use SiteUtils;

my $id = param("id");

if (!$id) {
    pageHead("PubNet - Error: Missing ID");
    print <<EOF;
<h1>Missing ID</h1>
<p>You must supply a valid identifier to save the data.</p>
EOF
pageFoot();
    die "Must supply id.";
}

my $domain = DOMAIN;

my ($gdl, $pdf, $png, $png_small, $ps, $svg, $xml1, $xml2, $topnet1, $topnet2, $params);

my $savename = param("name");
my $savecomm = param("comment");

my $f_id = P_OUT . "/$id"; # Filesystem ID
my $h_id = H_OUT . "/$id"; # Href ID

if ($savename || $savecomm) {
    # Use a Captcha test to prevent spam.
    my %p = Vars;
    my $ok = ($savecomm =~ /\*\*sesame\*\*$/);
    if ($ok) { $savecomm =~ s/\*\*sesame\*\*$//; }
    else { $ok = captchaCheck(\%p); }
    if (!$ok) { return; }
    system("mv $f_id*.* " . P_SAVED);
    $f_id = P_SAVED . "/$id";
    $h_id = H_SAVED . "/$id";
    open(SAVE, ">$f_id.save");
    print SAVE "$savename\n$savecomm\n";
    close(SAVE);
}


# Assumed:  ID has been submitted AND Captcha test was passed.


open(INFO, "<$f_id.txt");
my $qlist = <INFO>;
my $types = <INFO>;
close(INFO);

my ($query1, $query2) = split /\t/, $qlist;
my ($node, $edge) = split /\t/, $types;

my %nodes;
my %term_node;
my $report = "$f_id.report";

open(REPORT, "<$report");
while (<REPORT>) {
        my ($node, $term) = split /\t/;
        chomp $term;
        $nodes{$node} = $term;
}
close(REPORT);

foreach $key (keys(%nodes)) {
        my $list = $nodes{$key};
        my @terms = split(/,/, $list);  
        for (my $i = 0; $i < scalar(@terms); $i++) {
                $term_node{$terms[$i]}{$key} = 1;
        }
}

my @node_list = sort keys(%nodes);
my @edge_list = sort keys(%term_node);

pageHead("Pubnet - View $id");

viewQuery ($id, $h_id, $query1, $query2, $node, $edge);

my $day = substr($id,4,2);
my $month = substr($id,2,2);
my $year = "20" . substr($id,0,2);

print <<EOF;
<p>
<span style="color: #000099;">node:</span> $node<br />
<span style="color: #000099;">edge:</span> $edge<br />
<span style="color: #000099;">date:</span> $month / $day / $year<br />
EOF

my $savefile = "$f_id.save";
if (-e $savefile) { # Save form has been submitted.
    open(SAVE, "<$savefile");
    my $name = <SAVE>;
    my $comm = <SAVE>;
    close (SAVE);
    print <<EOF;
<br />
<span style="color: #000099;">Saved By:</span> $name<br />
<span style="color: #000099;">Comment:</span> $comm<br /><br />
<span style="color: #000099;">Permanent URL:</span> <a href="view.pl?id=$id&amp;so=s">http://$domain/cgi-bin/view.pl?id=$id&amp;so=s</a><br />
</p>
EOF
} 
else {
    print <<EOF;
</p>
<form action="save.pl" method="post">
<div>
<table style="margin-left: auto; margin-right: auto;">
<tr><td class="save">Your Name:</td><td><input type="text" name="name" /></td></tr>
<tr><td class="save">Comment:</td><td><input type="text" name="comment" /></td></tr>
<tr><td colspan="2"><input type="submit" name="Submit" value="Submit" class="button" /></td></tr>
</table>
<input type="hidden" name="id" value="$id" />
</div>
</form>
EOF
}


print <<EOF;
</div>
EOF
    pageFoot();

