#!/usr/bin/perl

use CGI ':param';
use HTML::Entities;
use SiteUtils;

use strict;

my $s = 0;
if (param()) {
  $s = param("s");
}

my $prefix = P_SAVED . "/";
my $filelist = `ls -r $prefix*.save`;
my @ids = split /\n/, $filelist;

my $prefix_l = length($prefix);
for (@ids) {
    $_ = substr($_, $prefix_l, 12);
}

my %alt;
my %names;
my %comments;

my $max = scalar(@ids);
my $e = $max;

if ($e > $s+16) {
  $e = $s + 16;
} 

for (my $i = $s; $i < $e; $i++) {
    my $id = $ids[$i];
    open(INFO, "<$prefix$id.txt");
	my $qlist = <INFO>;
	my $types = <INFO>;
	close(INFO);
	my ($query1, $query2) = split /\t/, $qlist;
	my ($node, $edge) = split /\t/, $types;
	chomp $query2;
	chomp $edge;

	open(SAVE, "<$prefix$id.save");
	my $name = <SAVE>;
	my $comment = <SAVE>;
	close(SAVE);
    chomp $name;
    chomp $comment;

	$names{$id} = $name;
	$comments{$id} = $comment;

	if ($query2) {
		$alt{$id} = "$query1 \n$query2 \nnode: $node \nedge: $edge"; 
	} else {
		$alt{$id} = "$query1 \nnode: $node\nedge: $edge"; 
	}
    $alt{$id} = encode_entities($alt{$id});
}

pageHead("PubNet - Gallery of User Submissions");

print qq[<div class="gallery">\n];

print qq[<h1 class="gallery" style="padding-bottom: 0px; margin-bottom: 0px;">Gallery of User Submissions</h1>\n
<h5 class="gallery" style="padding-top: 2px; margin-top: 0px;">(recent additions shown first)</h5>\n\n];

print qq[<div id="indexlist" class="gallery indexlist">\n];

for (my $j = 0; $j < $max; $j += 16) {
    my $a = $j+1;
    my $b = $a+15;
    if ($b > $max) {$b = $max;}
    if ($j == $s) {
	print qq[<a class="gallery" href="saved.pl?s=$j" style="font-weight:bold;">[$a-$b]</a> &nbsp;];
    }
    else {
	print qq[<a class="gallery" href="saved.pl?s=$j">$a-$b</a> &nbsp;];
    }
    if (! ($j % 128) && ($j)) { print "<br />"; }
}

print qq[</div>\n\n];

print qq[<table class="gallery">\n<tr class="gallery">\n];

for (my $i = $s; $i < $e; $i++) {
    my $id = $ids[$i];
    my $day = substr($id,4,2);
    my $month = substr($id,2,2);
    my $year = "20" . substr($id,0,2);
    my $imgsrc = "../saved/" . $id . "_micro.png";

    print qq[<td class="gallery">\n
<div class="gallery-img">\n
<a href="view.pl?id=$id&amp;so=s"><img\n 
src="$imgsrc"\n
alt="$alt{$ids[$i]}" title="$alt{$ids[$i]}" /></a><br />\n
Saved by: $names{$ids[$i]}<br />\n
Date: $month/$day/$year<br />\n
Comment:<br /> $comments{$ids[$i]}\n
</div>\n
</td>\n];

    if (! (($i + 1) % 4) && ($i + 1 != $e)) {
	print qq[</tr>\n<tr class="gallery">\n];
    }

}

print qq[</tr>\n</table>\n\n];

print qq[</div>];

    pageFoot();
