#!/usr/bin/perl

use strict;
use CGI ':param';

sub capitalize {
   local $_ = shift;
   s/\b(.*?)\b/$1 eq uc $1 ? $1 : "\u\L$1"/ge; 
   return $_;
}


my $BADPMIDS = "/web/pubnet/search/pmids.txt";
my $PM_URL;
my $PN_URL;
my $QUERY = param('query');
my $COAUTH = param('author');

$COAUTH = capitalize($COAUTH);

if (! $QUERY) {
	$QUERY = 'default';
}

open(PMIDS, $BADPMIDS);
$PM_URL = "http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?cmd=PureSearch&db=PubMed&details_term=";
$PN_URL = "http://pubnet.gersteinlab.org/cgi-bin/graph.pl?query1=";

$PM_URL .= "((Gerstein%20M[Author]%20NOT%20(1957[dp]%20:%201990[dp]))";
$PN_URL .= "((Gerstein%20M[Author]%20NOT%20(1957[dp]%20:%201990[dp]))";

while (<PMIDS>) {
	chomp;
	$PM_URL .= "\%20NOT\%20$_\[UID\]";
	$PN_URL .= "\%20NOT\%20$_\[UID\]";
}

$PN_URL .= "\%20NOT\%2014704431\[UID\]\%20NOT\%2012140549\[UID\]";

$PM_URL .= ")";
$PN_URL .= ")";

if (param('author')) {
	$PM_URL .= "\%20AND\%20$COAUTH";
	$PN_URL .= "\%20AND\%20$COAUTH";
}

$PM_URL .= "&dispmax=200&relpubdate=No+Limit";
$PN_URL .= "&node=author&edge=coauthor";

close(PMIDS);

if (!param('author')) {
	print "Location: $PM_URL\n\n";
} else {

	print "Content-type: text/html\n\n";
	print <<EOF;
<HTML><HEAD><meta HTTP-EQUIV="Content-Type" CONTENT="text/html; 
charset=UTF-8"><TITLE>Gerstein Lab Publications</TITLE></HEAD><BODY BGCOLOR="white">

<BLOCKQUOTE>

<CENTER>
<TABLE BORDER="0">
<TR>
<TD VALIGN="middle">
<CENTER>
<IMG SRC="http://papers.gersteinlab.org/papers/icons/title.png" ALT="Gerstein Lab Publications" BORDER="0">
</CENTER>
</TD>
</TR>
<TR><TD>&nbsp;</TD></TR>
<TR><TD>&nbsp;</TD></TR>
<TR>
<TD VALIGN="middle">
<CENTER>
<FONT FACE='sans-serif, Arial, Helvetica'><B>Query Lab Publications for <I>$COAUTH</I> in:<B></FONT>
</CENTER>
</TD>
</TR>
<TR><TD>&nbsp;</TD></TR>
<TR><TD>&nbsp;</TD></TR>
<TR>
<TD VALIGN="middle">
<CENTER>
<A HREF="$PM_URL"><IMG ALT="PubMed" BORDER=0 WIDTH=198 HEIGHT=60 SRC="http://pubnet.gersteinlab.org/search/pubmed.gif"></A>
</CENTER>
</TD>
</TR>
<TR><TD>&nbsp;</TD></TR>
<TR><TD>&nbsp;</TD></TR>
<TR>
<TD VALIGN="middle">
<CENTER>
<A HREF="$PN_URL"><IMG ALT="PubNet" BORDER="0" WIDTH="300" HEIGHT="69" SRC="http://pubnet.gersteinlab.org/images/mainlogo.jpg"></A>
</CENTER>
</TD>
</TR>
</TABLE>
</CENTER>
</BODY></HTML>
EOF
}

exit;
